import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;

/* Pozicija zivali */
class Koordinate {
    public double x, y;

    public Koordinate(double _x, double _y) {
        x = _x;
        y = _y;
    }
}

/* Smer gibanja; d = kot v radianih, v = hitrost v 1.0/korak */
class Smer {
    public double d, v;

    public Smer(double _d, double _v) {
        d = _d;
        v = _v;
    }
}

/* Pozicija in smer zivali*/
class Stanje {
    public Koordinate koordinate;
    public Smer smer;

    public Stanje(double x, double y, double d, double v) {
        koordinate = new Koordinate(x, y);
        smer = new Smer(d, v);
    }
}

class ZeljenaZacetnaSmer {
    public double Smer;
}

class ZeljenaSpremembaSmeri {
    public double dd;
    public double dv;
}

class Comms {
    BufferedReader reader;
    PrintWriter writer;
}

public class MMRuntime {
    public static void event_loop(Comms comms) throws Exception {

        Zival z;
        String cmd;
        String cmda[];

        while (true) {
            cmd = comms.reader.readLine();
            cmda = cmd.split(" ");

            if (cmda[0].equals("ADIJO")) return;
            if (cmda[0].startsWith("KONEC_IGRE")) continue;
            if (!cmda[0].equals("ZBUDI_SE")) throw new Exception("Napaka pri komunikaciji s streznikom.");
            Koordinate j0 = new Koordinate(Double.parseDouble(cmda[1]), Double.parseDouble(cmda[2]));
            Koordinate n0 = new Koordinate(Double.parseDouble(cmda[3]), Double.parseDouble(cmda[4]));

            z = new Zival();
            ZeljenaZacetnaSmer zs = new ZeljenaZacetnaSmer();
            z.ZbudiSe(j0, n0, zs);
            comms.writer.format("BUDNA %f\n", zs.Smer);
            comms.writer.flush();

            while (true) {
                cmd = comms.reader.readLine();
                cmda = cmd.split(" ");

                if (cmda[0].equals("ADIJO")) return;
                if (cmda[0].equals("KONEC_IGRE")) {
                    Zival.razlog r;
                    if (cmda[1].equals("0")) r = Zival.razlog.razlogNapaka;
                    else if (cmda[1].equals("1")) r = Zival.razlog.razlogZmagala;
                    else if (cmda[1].equals("2")) r = Zival.razlog.razlogZgubila;
                    else r = Zival.razlog.razlogNapaka;
                    z.KonecIgre(r);
                    z = null;
                    break;
                } else if (cmda[0].equals("QV")) {
                    Stanje j = new Stanje(Double.parseDouble(cmda[1]), Double.parseDouble(cmda[2]),
                                            Double.parseDouble(cmda[3]), Double.parseDouble(cmda[4]));
                    Stanje n = new Stanje(Double.parseDouble(cmda[5]), Double.parseDouble(cmda[6]),
                                            Double.parseDouble(cmda[7]), Double.parseDouble(cmda[8]));

                    ZeljenaSpremembaSmeri qv = new ZeljenaSpremembaSmeri();
                    z.KamGres(j, n, qv);

                    comms.writer.format("QVR %f %f\n", qv.dd, qv.dv);
                    comms.writer.flush();
                } else {
                }
            }
        }
    }

    public static void connect(String Hostname, Comms comms) throws Exception {
        Socket client = new Socket(Hostname, 1174);

        comms.reader = new BufferedReader(new InputStreamReader(client.getInputStream()));
        comms.writer = new PrintWriter(new OutputStreamWriter(client.getOutputStream()));

        String server = comms.reader.readLine();
        System.out.println(server);

        String tip = Zival.Tip == Zival.pasma.pasmaMuca ? "MACKA" : "MIS";
        comms.writer.println("AVE " + tip + " " + Zival.Ime);
        comms.writer.flush();

        String succ = comms.reader.readLine();
        if (!succ.equals("PRIJAVA USPESNA")) throw new Exception("Prijava na streznik neuspesna" + succ);
    }

    public static void main(String argv[]) throws Exception {
        String Hostname;
        if (argv.length < 2) Hostname = "localhost";
        else Hostname = argv[1];

        Comms comms = new Comms();
        connect(Hostname, comms);
        event_loop(comms);

    }
}
